library(fda)
library(MASS)
library(Matrix)

source("C:/NICHD/Research/software/Fan/Func_Linear_Model/FLM_web/FLM_fixed_model.R")
source("C:/NICHD/Research/software/Fan/Func_Linear_Model/FLM_web/FLM_FPCA.R")
source("C:/NICHD/Research/software/Fan/Func_Linear_Model/FLM_web/FLM_FPCA_no_position.R")
source("C:/NICHD/Research/software/Fan/Func_Linear_Model/FLM_web/FLM_beta_smooth_only.R")

###Generate phenotype and covariate data ###
covariate <- read.csv(file='C:/NICHD/Research/software/Fan/data/cov1.csv')
pheno     <- read.csv(file='C:/NICHD/Research/software/Fan/data/y1.csv')
covariate <- as.matrix(covariate)

#Get the genotype data 
genotype  <- read.csv(file='C:/NICHD/Research/software/Fan/data/geno1.csv')
pos  <- c(101:181)	   #set snp position
geno <- as.matrix(genotype[,1:81])

order  =  4
bbasis = 15
gbasis = 15
fbasis = 25
gfasis = 25

######################

Fixed_bspline_pvalue = flm_fixed_model(pheno, mode = "Additive", geno, pos, order, bbasis, fbasis, gbasis, covariate, base = "bspline", interaction = FALSE)
Fixed_fspline_pvalue = flm_fixed_model(pheno, mode = "Additive", geno, pos, order, bbasis, fbasis, gfasis, covariate, base = "fspline", interaction = FALSE)

Fixed_bspline_pvalue

Fixed_fspline_pvalue

#############

beta.smooth.only.bs = flm_beta_smooth_only(pheno, mode = "Additive", geno, pos, order, bbasis, covariate, base = "bspline", interaction = FALSE)

beta.smooth.only.bs

beta.smooth.only.fs = flm_beta_smooth_only(pheno, mode = "Additive", geno, pos, order, fbasis, covariate, base = "fspline", interaction = FALSE)

beta.smooth.only.fs

#############################

fpca.no.position = flm_fpca_no_position(pheno, mode = "Additive", geno, covariates = covariate, kz = 20, kb = 10, smooth.cov=FALSE, family = "gaussian")

fpca.no.position

fpca = flm_fpca(pheno, mode = "Additive", geno, covariates = covariate, pos, kz = 20, kb = 10, smooth.cov=FALSE, family = "gaussian")

fpca

